      subroutine egg1( period, rhoxx, phaxx, rhoxy, phaxy, 
     &            rhoyx, phayx, rhoyy, phayy, rho, pha )
c-----------------------------------------------------------------------

      implicit none

c-----------------------------------------------------------------------

      real period, rhoxx, phaxx, rhoxy, phaxy, rhoyx, phayx, 
     &             rhoyy, phayy, rho, pha, zm, ang
      complex zxx, zxy, zyx, zyy, lama, lamb
      real ornta,orntb,ella,ellb

      complex convr2z
      real convz2r, convz2p

c-----------------------------------------------------------------------
c     determine the tensor elements

      if( rhoxx.ne.0. ) then
        zxx = convr2z( rhoxx, phaxx, period )
      else
        zxx = cmplx( 0., 0. )
      endif

      zxy = convr2z( rhoxy, phaxy, period )
      zyx = convr2z( rhoyx, phayx, period )

      if( rhoyy.ne.0. ) then
        zyy = convr2z( rhoyy, phayy, period )
      else
        zyy = cmplx( 0., 0. )
      endif

c-----------------------------------------------------------------------
c     determine the Egger's decomposition


      call eggers(zxx,zxy,zyx,zyy,lama,lamb,ornta,orntb,ella,ellb)

      if( cabs(lama).lt.cabs(lamb) ) then
        lama = lamb
      end if

      rho = convz2r( lama, period )
      pha = convz2p( lama, period )

      return
      end
