      subroutine trunc (line, length)
      character*(*) line
      integer length,start,mid,end

      include 'ctrlblk.inc'

c
c this routine trims leading and trailing blanks from 'line', returning
c its new size in 'length'.  the actual length of the string remains
c unchanged; it is padded on the right with blanks if leading blanks are
c removed, but 'length' is not increased.
c
 
      length = len( line )
c
c      lastbl = len_trm( line )
c              ---- lnblnk is a sun fortran library function
c                   that returns the last non-blank char in a string
      lastbl = lnblnk( line )

      if( iprint.ge.20 ) then
        write(*,'(2a)')  'trunc: entered with line=',
     &                                        line(1:lnblnk(line))
        write(*,'(a,2i)')'       input length & last non-blank=',
     &                                        length, lastbl
      end if

      if( length.eq.0 .or. lastbl.eq.0 ) then
        length = 0
        return
      end if
 
      do 10 start = 1, length
c	write(*,*)'  start,line(start:start)=',start,' ',
c    &            line(start:start)
        if( line(start:start).ne.' ' ) goto 1
   10 continue
      length = 0
      return
 
    1 if( start.gt.1 ) then
        line(1:length-start+1) = line(start:length)
        line(length-start+2:length) = ' '
      end if
 
c
c do a binary search for the last non-blank character in 'line'.
c
      start = 1
      end = len(line)
      do while (start .lt. end)
        mid = (start+end)/2
        if (line(mid:end) .eq. ' ') then
           end = mid-1
        else
           start = mid+1
        end if
      end do
      if (line(start:start) .eq. ' ') then
        length = start-1
      else
        length = start
      end if

      if( iprint.ge.20 ) then
        write(*,*)'trunc: leaving with length=',length
      endif

      return
      end
